/*
 * Preferences.java
 *
 * Created on December 2, 2007, 6:04 PM
 */

package com.meapsoft.gui;

import java.awt.Color;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowEvent;

import sun.awt.WindowClosingListener;

import com.meapsoft.MEAPUtil;

/**
 *
 * @author  Mike
 */
public class SettingsDialog extends javax.swing.JDialog implements ComponentListener
{
    private MeapsoftGUI mMainScreen = null;
    private boolean mOldColors = false;
    private boolean mOldFlash = false;
    private String mOldDatabaseName = "";
    private boolean mOldSaveFiles = false;
    
    //did we save our settings?
    private boolean mSaved = false;
    
    
    /** Creates new form Preferences */
    public SettingsDialog(MeapsoftGUI mainScreen)
    {
    	super(mainScreen, true);
    	
        //initialize our components
        initComponents();
    	
        //save a reference to the main screen
        mMainScreen = mainScreen;
    	
        //add us as a component listener
        addComponentListener(this);
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mSaveBtn = new javax.swing.JButton();
        mCancelBtn = new javax.swing.JButton();
        mRegenerateColorsBtn = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        mDatabaseTxt = new javax.swing.JTextField();
        mFlashColors = new javax.swing.JCheckBox();
        mColorsChk = new javax.swing.JCheckBox();
        mSaveFilesChk = new javax.swing.JCheckBox();

        setTitle("Settings");
        setResizable(false);

        mSaveBtn.setText("Save");
        mSaveBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mSaveBtnActionPerformed(evt);
            }
        });

        mCancelBtn.setText("Cancel");
        mCancelBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mCancelBtnActionPerformed(evt);
            }
        });

        mRegenerateColorsBtn.setText("Regenerate colors");
        mRegenerateColorsBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mRegenerateColorsBtnActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/settings.png"))); // NOI18N
        jLabel1.setText("Settings");

        jSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);

        jLabel2.setText("Color");

        jLabel3.setText("Files");

        jLabel4.setText("File base name:");

        mDatabaseTxt.setText("mann");

        mFlashColors.setSelected(true);
        mFlashColors.setText("Flash Colors when Meaping");

        mColorsChk.setSelected(true);
        mColorsChk.setText("Colorful Meapsoft");

        mSaveFilesChk.setSelected(true);
        mSaveFilesChk.setText("Save .edl, .feat, and .seg files");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(103, 103, 103)
                .add(mSaveBtn)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(mCancelBtn)
                .addContainerGap(153, Short.MAX_VALUE))
            .add(layout.createSequentialGroup()
                .add(jLabel1)
                .addContainerGap(312, Short.MAX_VALUE))
            .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 412, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel2)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(mColorsChk)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 25, Short.MAX_VALUE)
                        .add(mRegenerateColorsBtn))
                    .add(jSeparator3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 304, Short.MAX_VALUE)
                    .add(mFlashColors)
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(mDatabaseTxt, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE))
                    .add(mSaveFilesChk))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .add(40, 40, 40)
                        .add(jLabel3))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(mRegenerateColorsBtn)
                                    .add(mColorsChk))
                                .add(5, 5, 5)
                                .add(mFlashColors)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jSeparator3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(mSaveFilesChk)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel4)
                                    .add(mDatabaseTxt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(8, 8, 8))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jSeparator2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 123, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(mCancelBtn)
                            .add(mSaveBtn, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void mRegenerateColorsBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_mRegenerateColorsBtnActionPerformed
    {//GEN-HEADEREND:event_mRegenerateColorsBtnActionPerformed
    	
    	mMainScreen.initColors();
    	
    }//GEN-LAST:event_mRegenerateColorsBtnActionPerformed

    private void mSaveBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_mSaveBtnActionPerformed
    {//GEN-HEADEREND:event_mSaveBtnActionPerformed
        
    	mSaved = true;
        this.setVisible(false);
        
    }//GEN-LAST:event_mSaveBtnActionPerformed

    private void mCancelBtnActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_mCancelBtnActionPerformed
    {//GEN-HEADEREND:event_mCancelBtnActionPerformed
    	
    	mSaved = false;
    	this.setVisible(false);
    	
    }//GEN-LAST:event_mCancelBtnActionPerformed
      

    public void initColors(boolean flag)
    {
    	Color panelColor = flag ? mMainScreen.getColor() : null;
    	GUIUtils.initContainerColor(this, panelColor);
    }
    
	public void componentShown(ComponentEvent e) 
	{
		//set the color!
		//initColors(mMainScreen.isColorEnabled());
		
		//a saved flag
		mSaved = false;
		
		//set the textbox for the database name
		mDatabaseTxt.setText(BasePanel.dataBaseName);
		
        //save our old values
        mOldColors = mColorsChk.isSelected();
        mOldFlash = mFlashColors.isSelected();
        mOldDatabaseName = mDatabaseTxt.getText();
        mOldSaveFiles = mSaveFilesChk.isSelected();
	}
	
	public void componentHidden(ComponentEvent e) 
	{
    	//rollback to all our old values
		if(mSaved)
		{
	    	//same value? don't do anything
	        if(mOldColors != mColorsChk.isSelected())
	        {
		        //set this and init the colors
		        mMainScreen.setColorEnabled(mColorsChk.isSelected());
		        mMainScreen.initColors();
	        }
	        
	        //set the flash colors flag
	        mMainScreen.setFlashColors(mFlashColors.isSelected());
	        
	        //update our database name here
	        BasePanel.dataBaseName = mDatabaseTxt.getText();
	        BasePanel.updateFileNames();
	        
	        //now reinit the files for the panels
	        mMainScreen.initFilesForPanels();
	        
	        //update the write meap file checkbox
	        MEAPUtil.writeMEAPFile = mSaveFilesChk.isSelected();
		}
	    else    	
	    {
	    	mColorsChk.setSelected(mOldColors);
	    	mFlashColors.setSelected(mOldFlash);
	    	mSaveFilesChk.setSelected(mOldSaveFiles);
	    	mDatabaseTxt.setText(mOldDatabaseName);
		}
		
	}

	public void componentMoved(ComponentEvent e) 
	{	
	}

	public void componentResized(ComponentEvent e) 
	{	
	}
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JButton mCancelBtn;
    private javax.swing.JCheckBox mColorsChk;
    private javax.swing.JTextField mDatabaseTxt;
    private javax.swing.JCheckBox mFlashColors;
    private javax.swing.JButton mRegenerateColorsBtn;
    private javax.swing.JButton mSaveBtn;
    private javax.swing.JCheckBox mSaveFilesChk;
    // End of variables declaration//GEN-END:variables


}
